/*
DataFile 

License: GNU General Public License

Cordier Yves 24/04/2016


	This unit is use to get easily numeric values
	from a text file. It could read
	positive integer
	relative integer
	reals either notation xx.yy and xx.yyEzz
	where xx and zz are a relative (positive or negative with a -)
	in an otherr hand, it permises to include
	end of line comments (preceded a char selected by setComment(int) fonction)
	by default ther is no comment char (setComment(-1))
	
	see the example program
	
V1.00 : 24/04/2016

	This unit is use to get easily numeric values
	from a text file. It could read
	positive integer
	relative integer
	reals either notation xx.yy and xx.yyEzz
	where xx and zz are a relative (positive or negative with a -)
	in an otherr hand, it permises to include
	end of line comments (preceded a char selected by setComment(int) fonction)
	by default ther is no comment char (setComment(-1))
	
	see the example program
	
V2.00 : 20/03/2020
	extensions of possibilities of this librarie
	more easier code to open close ... files
	ability to write floats double with format
	in one word a pascal style file function
	
V2.01 : 23/03/2020
	correction of a minor bug in printing scientific mode 
	(add rounding of decimal part)

V2.10 : 25/03/2020
	normalizing name of function according camelBack spelling
	accept the function readln() with no argument ie readln(NULL)
	accept readln with a char[] in argument (as well as String)


V2.11 : 02/04/2020
	correction of a pernicious bug when using 0x00 as comment character
	
	

*/
// *************************
// DataFile.cpp file
// *************************
/******************************************************************************
* Includes
******************************************************************************/
#include "DataFile.h"

// definition des methodes
// *************************
// Les constructeurs
DataFile::DataFile(SdFile f, const char *name):
SDFile(f, name) // inherited constructor :  wraps an underlying SdFile
{
	setComment(-1); // No comment alaouded
}

DataFile::DataFile(void): File() // 'empty' inherited constructor
{
	setComment(-1); // No comment alaouded
}

// ***************************
// ouverture du fichier

boolean DataFile::open(const char *filename, uint8_t mode)
{ if (SDFile f = SD.open(filename, mode)) // open the file in the SD structure
	{
		// copy temporary structure SDFile créated on our file (daughter of SDFile !!!)
		memcpy(this, &f, sizeof(SDFile)); // this is a "self" pointer
		return true;
	}
	else
	{
		return false;
	}
}

// **************************
// fonction end of file

boolean DataFile::eof() // end of file
{return (peekComment()<0);}


int DataFile::peekComment() // peek but skipping the comments
{
	int c =  peek();
	if (carComment < 0 )
	{
		return c;
	}
	if (c == carComment)
	{
		while (((c = read()) > 0) && (c != 13)); // passer jusqu'a la fin de ligne
	}
	return peek();
}
// ***********************************************
// passage des commentaires jusqu'en bout de ligne
int DataFile::readComment()// read but skipping the comments

{
	int c =  peek();
	if (carComment == 0 )
	{
		return read();
	}
	if (c == carComment)
	{
		while (((c = read()) > 0) && (c != 13)); // passer jusqu'a la fin de ligne;
	}
	c= read();
	if (c==10) {return 32;} else {return c;}
}

// *****************************************
// mise en place du caractère de commentaire

void DataFile::setComment(int c)
{
	if (c>0)carComment = c;
	else carComment=0;
}

// ***************************
// skip de la fin de ligne

void DataFile::skipEoln()
{
	int c;
	while (((c = peekComment()) > 0) && (c != 10))
	{
		readComment(); // avancer
	}
}

// **********************************
// skip des caractères non numériques

void  DataFile:: skipNonNumeric(boolean minus)
{
	boolean reste = true;
	int c;
	while (reste & ((c = peekComment()) > 0))

	{
		if ((reste = (!(((c == '-')&& minus) || ((c >= '0') & (c <= '9'))))))
		{
			readComment(); // avancer
		}
	}

}


unsigned long DataFile::update()
{ 
	// lecture de la partie entiere
	unsigned long result = 0;
	boolean reste = true;
	byte c;
	while ( reste &= ((c = peekComment()) > 0))
	{
		//  chiffre ??
		if (( reste = ((c >= '0') && (c <= '9'))))
		{
			result = result * 10 + (c - '0');
			readComment(); // on avance
		}
	}
	return result;
}
// ***************************
// Lecture d'un entier positif
// ***************************
unsigned long DataFile::readPos()
{
	skipNonNumeric(false);
	return(update());
}
// ***************************
// lecture d'un entier relatif
// ***************************
long  DataFile::readLong()
{
	skipNonNumeric(true); // passe tous les caractères non numériques et -

	// recherche du signe - eventuel
	int c;
	if ( (c = peekComment()) > 0)
	{ if (c == '-')
		{ readComment(); // on avance
			return (-readPos());
		}
		else
		{
			return (readPos());
		}
	}
	return 0;
}

// **************************************
// lecture d'un nombre réel
// [-][<0..9>][.][<0...9>][E][-][<0..9>]
// [x] : x optionnel
// [<x>] : répétion de x
// [x..y] : caractere entre
// exemple : -12.342E-6 ; 10. ; -5E6 ; -6
// **************************************

float  DataFile::readFloat()
{
	float result = 0;
	float deci = 0;
	float posit = 0.1;
	boolean reste = true;
	int c;
	int signeExpo = 1;
	int expo = 0;
	// lecture de La mantisse
	result = readLong(); // lecture de la partie entiere
	// lecture de la partie decimale
	if ((c = peekComment()) == '.')
	{
		readComment(); // on avance d'un cran
		while (reste &= ((c = peekComment()) > 0)) // prise de la partie decimale
		{
			if ((reste = ((c >= '0') & (c <= '9'))))
			{
				deci = deci + posit * (c - '0');
				posit = posit / 10;
				readComment(); // on avance
			}
		}
	}
	// Lecture de la partie puissances de dix
	if ((c = peekComment()) == 'E')
	{
		readComment(); // on avance d'un cran
		if ((c = peekComment()) == '-')
		{
			readComment(); // on avance
			signeExpo = -1;
		}
		// prise de la puissance de dix
		expo = signeExpo * readPos();
	}
	if (result >= 0)
	{
		result = (result + deci);
	}
	else
	{
		result = -(-result + deci);
	}
	// Prise en compte de l'expo decimale
	while (expo > 0)
	{
		result = result * 10;
		expo--;
	}
	while (expo < 0)
	{
		result = result / 10;
		expo++;
	}
	return result;
}
// ***************************************************
// lecture d'un reel puis passage à la ligne suivante
// ***************************************************
float DataFile::readFloatln() // lit un réel venant du fichier et va à la ligne (renvoi 0 si erreur)
{
	float res = readFloat();
	skipEoln();
	return res;
}
// ******************************************************
// lecture d'un relatif puis passage à la ligne suivante
// ******************************************************

long DataFile::readLongln()// lit un entier venant du fichier et va à la ligne(renvoi 0 si erreur)
{
	long res = readLong();
	skipEoln();
	return res;
}

// ******************************************************
// impression d'un flotant ou double 
// ******************************************************

void DataFile::printFloat(double d, int n, int dec) // print a double with ndigits and dec digits after point
// max total 20 digits 

{
	char r[21]; // buffer long enough to get a 20 char string
	if (n>20) n=20;
	dtostrf(d,n,dec,r);
	print(r);
}
void DataFile::printFloatln(double d, int n, int dec) // print a double with ndigits and d digits after point
{
	printFloat(d,n,dec);
	println();
}

void DataFile::printScienti(double d, int dec ) // print a double scientific methode with n digits decimal 
{
	if (d<0) 
	{
		print('-');
		d=-d;
	}
	int exp =0;
	while (d>=10) {exp++; d/=10;} // search of exponent 10^x if >0
	while ((d<1)&&(d>0)) {exp--; d*=10;} // search of exponent 10^-x if <0
	// now d in in range [0,10[
	
	// Round correctly so that print(1.999, 2) prints as "2.00"
	double rounding = 0.5;
	for (uint8_t i=0; i<dec; ++i) // compute the smallest part of rounding depends on digis
	rounding /= 10.0;
	d += rounding; // increase the number by this small part
	// verifying the range
	if (d>=10) {d/=10; exp++;}
	
	byte ent=d; // ent part of d  <10
	print(ent);
	d=d-ent; // decimal part of d
	if (dec>0)
	{
		print('.');
		for (byte i=0; i<dec; i++) // print decimal part
		{
			d=d*10; 
			byte dig=byte(d);
			write(48+dig);
			d-=dig; 
		}	
		
	}
	
	// print exponent "e" {+|-} {dig (2|3)}
	print('e');
	if (exp>=0) print('+'); else print('-');
	exp=abs(exp);
	if (exp <10) write(48); // character '0'
	print(exp);
}

void DataFile::printScientiln(double d, int dec ) // print a double scientific methode with n digits decimal 
{printScienti(d, dec ); println();}


// ******************************************************
// lecture d'une chaine  
// ******************************************************

boolean DataFile::readln()
{
	int c=0;
	while (((c=read())>0) && (c!=10)); // char 0x0A detected	
	return (c>0);
}	

boolean DataFile::readln(String &S) // S is a pointer *S a String
{
	
	S="";
	int c=0;
	while (((c=read())>0) && (c!=10)) // char 0x0A detected
	{
		if (c!=13) S=S+char(c); // line feed => 0x0D 0x0A (CR LF) (13 10)
	}
	return (c>0);
	
}

boolean DataFile::readln(char S[]) // S is a pointer *S a String
{
	if (S) // ie S!=NULL
	{
		S[0]=0;
		int c=0;
		int p=0;
		while (((c=read())>0) && (c!=10)) // char 0x0A detected
		{
			if (c!=13) S[p]=c;// line feed => 0x0D 0x0A (CR LF) (13 10)
			else S[p]=0;
			p++;		
		}
		return (c>0);
	}
	else
	{
		int c=0;
		while (((c=read())>0) && (c!=10)); // char 0x0A detected	
		return (c>0);
	}	
	
}
// *************************
// end of DataFile.cpp file
// *************************
