// this test program tries to include all the main possibilities of
// the datafile librarie
// all that you need is a SD shield connected to pin 4 for CS

#include <DataFile.h>
#define _CS_SD 4 // le Chip Select de la carte sD


// ******************
// The setup function
void setup()
{
  Serial.begin(9600); // to be able to show data on computer
  //Initialisation of SD

  if (!SD.begin(_CS_SD)) // attached SD at pin _CS_SD and create file system
  {
    Serial.println(F("SD error")); // F() means "..." store in same memory as program
    // it saves place on data memory
    return;
  }
  Serial.println(F("Initialisation OK"));// put your setup code here, to run once:

}

// ******************************
// various demonstration function

// reading a file line by line and printing it to Serial
// -----------------------------------------------------
boolean readFile(char nom[13], int comment)
{
  DataFile fichier;
  fichier.setComment(comment);
  if (fichier.open(nom, FILE_READ)) // open it and go on if file exist
  {
    String S = "";
    while (fichier.readln(S)) Serial.println(S);
    fichier.close();
    return true;
  }
  return false;
}

// destroying a file
// -----------------
void killFile(char nom[13])
{
  SD.remove(nom); // delete the actual file if exist
}


// test of text files
// writing and reading text file with formated values

void fichierTexte()
{ char nom[] = "essaitxt.txt";
  killFile(nom);
  DataFile fichier; // a DataFile structure
  Serial.println("essai de fichier texte");
  Serial.println("**********************");
  if (fichier.open(nom, FILE_WRITE)) // open it and go on if file exist
  {
    byte b = 127;
    int i = -2000;
    long l = 70000;
    float f = PI;
    double d = -double(2) * PI/100;
    fichier.print("un byte   : "); fichier.println(b);
    fichier.print("un int    : "); fichier.println(i);
    fichier.print("un long   : "); fichier.println(l);
    fichier.print("un float  : "); fichier.print(f); fichier.print(';');  fichier.printFloat(f, 7, 4);fichier.print(';');  fichier.printScientiln(f, 3);
    fichier.print("un double : "); fichier.print(d); fichier.print(";");  fichier.printFloat(d, 9, 6);fichier.print(';');  fichier.printScientiln(d, 4);
    fichier.close();

    if (!readFile(nom, -1))
    {
      Serial.print("enable to read file ");
      Serial.println(nom);
    }
  }
  else
    Serial.println("unable to create the text file");
}

// ******************
// test of data files

void fichierDonneesNumerique()
{ char nom[] = "essainum.txt";
  killFile(nom);
  DataFile fichier; // a DataFile structure
  Serial.println("essai de fichier numerique");
  Serial.println("**************************");
  if (fichier.open(nom, FILE_WRITE)) // open it and go on if file exist
  {
    fichier.println("# fichier de données de type CSV");
    fichier.println("# caractere separateur ;");
    fichier.println();

    fichier.print(random(100));
    for (int i = 0; i < 9; i++)
    {
      fichier.print(';');
      fichier.print(random(100));
    }
    fichier.println("# suite de 10 entiers");

    fichier.printFloat((random(10000) / 1000.), 5, 3);
    for (int i = 0; i < 9; i++)
    {
      fichier.print(';');
      fichier.printFloat((random(10000) / 1000.), 5, 3);
    }
    fichier.println("# suite de 10 réels");
    fichier.close();

    // read the file as it is
    if (!readFile(nom, -1))
    {
      Serial.print("unable to read file");  // open it and go on if file exist// relecture et affichage du fichier
      Serial.print(nom);
      Serial.println(" as is") ;
    }

    // read back values and print them
    if (fichier.open(nom, FILE_READ)) // open it and go on if file exist
    {
      Serial.print("Interpretation du fichier "); Serial.println(nom);
      fichier.setComment('#');
      for (int i = 0; i < 10; i++)
      {
        Serial.print(fichier.readLong());

        Serial.print('|');
      }
      Serial.println();
      for (int i = 0; i < 10; i++)
      {
        Serial.print(fichier.readFloat(), 4);
        Serial.print('|');
      }
      Serial.println();
      fichier.close();
    }
    else
    {
      Serial.print("unable to read ");
      Serial.print(nom);
      Serial.println(" data file");
    }
  }
  else
    Serial.println("unable to create data file");
}

// **************
// loop procedure
void loop()
{
  static boolean premier = true;
  if (premier)
  {
    fichierTexte();
    delay(1000);
    fichierDonneesNumerique();
    premier = false;
  }
  delay(100);
}
